//import spout.*;
import processing.serial.*;


/*
 * This sketch uses as base the code written by Amnon Owed inside, outside --> instead of using a font I use the svg 
 * Connects to arduino on port 2
 * uses svg files as pshapes and loads them into pgraphics
 *capacitive touch sensor with adafruit cap1188
 */

// SKETCH SETTINGS, VARIABLES
PShape en;
PShape nl;
PShape obj;
int i = 1;
int p = 1;
int in = 1;
int pn = 1;
int num = 12;
int radial =200;
float grey;
float huepurp;
float trans;
int width1 = 759;
int height1 = 1003;

Serial myPort;
String val;
int lf=10;
int number;
int reference;
boolean callMethod = false;
boolean filty = false;
boolean elipseme = true;

color PGRAPHICS_COLOR = color(0);

PGraphics pg_en; // initialize PGraphics instance
PGraphics pg_nl; // initialize PGraphics instance
PGraphics pg_obj; // initialize PGraphics instance 

// DECLARE A SPOUT OBJECT
//Spout spout;

// SKETCH SETUP

void setup() {
  //size(759, 1003, P3D);
  fullScreen(P3D);
  frameRate(8);
  colorMode(HSB, 250, 100, 100);
  ellipseMode(RADIUS);
  textureMode(NORMAL);
  
  //creating three layers as separate PGraphic elements
  
  en = loadShape ("dot_en8-01.svg"); //load file into PShape
  pg_en = createGraphics(759, 1003, JAVA2D); // create a PGraphics the same size as the main sketch display window
  // create and draw to PPraphics (see Getting Started > UsingPGraphics example)     
  // Now let's draw something to the created PGraphics instance called 'pg'.  
  // Note 1: Always put all drawing commands to a PGraphics between beginDraw/endDraw calls
  // Note 2: Always put the name of the PGraphics (in this case 'pg') plus a . (aka dot) before the drawing commands to a PGraphics
 
 // for(int child=1; child<8;){
 //           String chi = str(child);
 //           PShape chili= en.getChild(chi);
 //           PShape[] layers = new PShape[6];
 // PShape child1 = en.getChild("1");          
  pg_en.beginDraw(); // start drawing to the PGraphics
  //
  pg_en.shape(en, 0,0, 759, 1003);
  //pg_en.shape(child1, 0,0, width, height);
  pg_en.endDraw(); // finish drawing to the PGraphics
  
  ///
  nl = loadShape ("dotnr_nl11-01.svg"); //load file into PShape
  
  pg_nl = createGraphics(759, 1003, JAVA2D); // create a PGraphics the same size as the main sketch display window
  
  pg_nl.beginDraw();
  pg_nl.shape(nl,0,0, 759, 1003);
  pg_nl.endDraw();
  
  ///
  obj = loadShape ("obj-blackree-01.svg"); //load file into PShape
  
  pg_obj = createGraphics(759, 1003, JAVA2D); // create a PGraphics the same size as the main sketch display window

  pg_obj.beginDraw();
  pg_obj.shape(obj,0,0,759, 1003);
  pg_obj.endDraw();
  
 
  printArray(Serial.list());
  myPort = new Serial(this, Serial.list()[2], 9600); // CONNECTING TO SERIAL PORT 2
  val = myPort.readStringUntil(lf); ;  // READS STRING VALUE FROM SERIAL PORT AND STORES IT IN val
  val = null;
  
  // CREATE A NEW SPOUT OBJECT
  //spout = new Spout(this);
 // spout.createSender("Spout Processing");
}


void draw() {
  //background(0);
  fill(0,0,0,15);
  rect(0,0,width,height);
  greybg();  
  
  while (myPort.available() > 0) {
    val = myPort.readStringUntil(lf);
    if (val != null) {
      try{
      //println(val);
      number = Integer.parseInt(val.trim());
      }catch(NumberFormatException npe){
       // Not an integer so forget it
      }
    }
  }
 
  if((number == 1)||(number == 11)||(number == 111)){    //if touched
  //int check = number;
   // if(number == check){
      //callMethod = false;}else{
     // callMethod = true;
     // }
      
      if(callMethod == false){ 
      myMethod();
      println(number);
      }
     
     
     if((number ==1)&&(reference ==1)){
      english();
      //ellipseMode(CENTER);
      }
      
      if((number ==1)&&(reference ==0)){
      nl();
      //ellipseMode(CENTER);
     }
  }
  //grey=random(10,50);
  //println(grey);
 // spout.sendTexture();
  //filter(INVERT);
}
  
  
void greybg(){
  int gridHorizontal = (int) map(in, 0, width1, 1, 100); // number of horizontal grid cells 
  int gridVertical = (int) map(pn, 0, height1, 15, 200); // number of vertical grid cells 
 
  float w = float(width1) / gridHorizontal;
  float h = float(height1) /gridVertical;
  float r = min(w, h);
  
                
  for (int y=0; y<gridVertical; y++) {
     
        for (int x=0; x<gridHorizontal; x++) {
          float e_x = x * w;
          float e_y = y * h;
          grey=random(80,100);
          color c = pg_obj.get(int(e_x), int(e_y)); // get PGraphics color at this coordinate
            if (c == PGRAPHICS_COLOR){ // is the color equal to PGRAPHICS_COLOR (aka is there text here)
                //huepurp = random(0, 1);
               
                trans = random(70,100);
                for (float re = r; re > 0; --re) {
                
                //grey = map(i, 0, num-random(1,10), 0, 10);
                //grey=random(10,80);
                noStroke();
                fill(0,0,grey,trans);
                //filter(blur);
                if(elipseme == true){
                 ellipseMode(RADIUS);
                 } else { 
                 ellipseMode(CENTER);
                 }
                ellipse(e_x, e_y, re*random(1.5,4), re*random(1.5,4));
                //ellipse(e_x, e_y, r, r);
                grey = (grey+1) % 260;
                //trans = trans +2;
              }
        }
      }}
  in = in +1;
  pn =pn+1;
  //println("in is" + in + "pn is"+pn);
  
  if((in > 300)||(pn > 300)){
    in = 1;
    pn = 1;
    //filter(INVERT);
  }
  
  
}
      
void myMethod(){
  
  reference = (int) random(0,1.5);
  println("reference =" + reference);
  callMethod = true;
  
  
}
void english(){
  elipseme = false;
  frameRate(8);
     
  int gridHorizontal = (int) map(i, 0, width1, 1, 300); // number of horizontal grid cells (based on mouseX)
  int gridVertical = (int) map(p, 0, height1, 15, 300); // number of vertical grid cells (based on mouseY)
 
  float w = float(width1) / gridHorizontal;
  float h = float(height1) /gridVertical;
  float r = min(w, h);
  
 if((reference == 1)&&((i < radial)||(p<radial))){
    // ellipseMode(CENTER);
     //frameRate(8);
     //grey = random(0,20);
     //in= 300;
     //pn=300;
     for (int y=0; y<gridVertical; y++) {
        for (int x=0; x<gridHorizontal; x++) {
          float e_x = x * w;
          float e_y = y * h;
         
          color c = pg_en.get(int(e_x), int(e_y)); // get PGraphics color at this coordinate
            if (c == PGRAPHICS_COLOR){ // is the color equal to PGRAPHICS_COLOR (aka is black)
                noStroke();
                fill(360,0,100,250);
                ellipseMode(RADIUS);
                ellipse(e_x, e_y, r*random(0.5,4), r*random(0.5,4));
               // if(i>=50){
                //redraw();
               // }
              } 
             // child++;
          //}
        }
      }
    }else{
      i =1;
      p =1;
      in= 200;
      pn=200;
      number = 0;
      callMethod = false;
      //ellipseMode(RADIUS);
      elipseme = true;
      //filter(INVERT);
      return;
    }
    i = i +1;
    p =p+1;
    //println("i is" + i + "p is"+p);
    
    
}

void nl(){
  elipseme = false;
  frameRate(8);
  int gridHorizontal = (int) map(i, 0, width1, 1, 200); // number of horizontal grid cells 
  int gridVertical = (int) map(p, 0, height1, 10, 300); // number of vertical grid cells 
 
  float w = float(width1) / gridHorizontal;
  float h = float(height1) /gridVertical;
  float r = min(w, h);
  //println("w is " + w + " h is " + h);
  if((reference == 0)&&((i < radial)||(p<radial))){
     //ellipseMode(CENTER);
     //frameRate(8);
     //grey = random(0,20);
     //in= 300;
     //pn=300;
     for (int y=0; y<gridVertical; y++) {
        for (int x=0; x<gridHorizontal; x++) {
          float e_x = x * w;
          float e_y = y * h;
          color c = pg_nl.get(int(e_x), int(e_y)); // get PGraphics color at this coordinate
            if (c == PGRAPHICS_COLOR){ // is the color equal to PGRAPHICS_COLOR (aka is there text here)
                noStroke();
                fill(360,0,100,250);
                //filter(blur);
                ellipseMode(RADIUS);
                ellipse(e_x, e_y, r*random(1,3), r*random(1,3));
            }
              } 
        }
      }else{
    i= 1;
    p=1;
    in= 200;
    pn= 200;
    number = 0;
    callMethod = false;
    //ellipseMode(RADIUS);
    elipseme = true;
    //filter(INVERT);
    return;
    }
    
    i = i +1;
    p =p+1;
    //println("i is" + i + "p is"+p);
    
    
}
       
        
       //gridHorizontal = gridHorizontal+0.5;
  //gridVertical = gridVertical+0.5;
  
          
  


      
    
